diff --git a/modules/PowerManagement_1-2/module.c b/modules/PowerManagement_1-2/module.c
index b7c3ec6..6926136 100644
--- a/modules/PowerManagement_1-2/module.c
+++ b/modules/PowerManagement_1-2/module.c
@@ -1390,78 +866,218 @@ aos_unittest_t moduleUtAlldAt42qt1050 = {
 /*
  * PCAL6524 (GPIO extender)
  */
-static int _utShellCmdCb_AlldPcal6524(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_PCAL6524.h>
+static int _testPcal6524ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  // evaluate arguments
-  if (argc == 2) {
-    if (strcmp(argv[1], "#1") == 0) {
-      ((ut_pcal6524data_t*)moduleUtAlldPcal6524.data)->pcal6524d = &moduleLldGpioExtender1;
-      aosUtRun(stream, &moduleUtAlldPcal6524, "I2C bus #1");
-      ((ut_pcal6524data_t*)moduleUtAlldPcal6524.data)->pcal6524d = NULL;
-      return AOS_OK;
-    }
-    else if (strcmp(argv[1], "#2") == 0) {
-      ((ut_pcal6524data_t*)moduleUtAlldPcal6524.data)->pcal6524d = &moduleLldGpioExtender2;
-      aosUtRun(stream, &moduleUtAlldPcal6524, "I2C bus #2");
-      ((ut_pcal6524data_t*)moduleUtAlldPcal6524.data)->pcal6524d = NULL;
-      return AOS_OK;
-    }
-  }
-  // print help
-  chprintf(stream, "Usage: %s OPTION\n", argv[0]);
-  chprintf(stream, "Options:\n");
-  chprintf(stream, "  #1\n");
-  chprintf(stream, "    Test the GPIO extender on the I2C bus #1.\n");
-  chprintf(stream, "  #2\n");
-  chprintf(stream, "    Test the GPIO extender on the I2C bus #2.\n");
-  return AOS_INVALIDARGUMENTS;
+  return moduleTestPcal6524ShellCb(stream, argc, argv, NULL);
 }
-static ut_pcal6524data_t _utAlldPcal6524Data = {
-  /* driver   */ NULL,
-  /* timeout  */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldPcal6524 = {
-  /* name           */ "PCAL6524",
-  /* info           */ "GPIO extender",
-  /* test function  */ utAlldPcal6524Func,
-  /* shell command  */ {
-    /* name     */ "unittest:GPIOExtender",
-    /* callback */ _utShellCmdCb_AlldPcal6524,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utAlldPcal6524Data,
-};
+AOS_SHELL_COMMAND(moduleTestPcal6524ShellCmd, "test:GPIOExtenter", _testPcal6524ShellCmdCb);
 
 /*
  * AT42QT1050 (touch sensor)
  */
-static int _utShellCmdCb_AlldAt42qt1050(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_AT42QT1050.h>
+static int _testAt42qt1050ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  return moduleTestAt42qt1050ShellCb(stream, argc, argv, NULL);
+}
+AOS_SHELL_COMMAND(moduleTestAt42qt1050ShellCmd, "test:Touch", _testAt42qt1050ShellCmdCb);
+
+#endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) */
+
+/*
+ * entire module
+ */
+static int _testAllShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
   (void)argc;
   (void)argv;
-  aosUtRun(stream, &moduleUtAlldAt42qt1050, NULL);
-  return AOS_OK;
-}
-static ut_at42qt1050data_t _utAlldAt42qt1050Data= {
-  /* AT42QT1050 driver  */ &moduleLldTouch,
-  /* timeout            */ MICROSECONDS_PER_SECOND,
-  /* event source       */ &aos.events.io,
-  /* event flags        */ MODULE_OS_IOEVENTFLAGS_TOUCHINT,
-};
-aos_unittest_t moduleUtAlldAt42qt1050 = {
-  /* name           */ "AT42QT1050",
-  /* info           */ "touch sensor",
-  /* test function  */ utAlldAt42qt1050Func,
-  /* shell command  */ {
-    /* name     */ "unittest:Touch",
-    /* callback */ _utShellCmdCb_AlldAt42qt1050,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utAlldAt42qt1050Data,
-};
+
+  int status = AOS_OK;
+  char* targv[AMIROOS_CFG_SHELL_MAXARGS] = {NULL};
+  aos_testresult_t result_test = {0, 0};
+  aos_testresult_t result_total = {0, 0};
+
+  /* ADC */
+  status |= moduleTestAdcShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* AT24C01BN-SH-B (EEPROM) */
+  status |= moduleTestAt24c01bShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* bq24103a (battery charger) */
+  // front
+  targv[1] = "-f";
+  status |= moduleTestBq241xxShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // rear
+  targv[1] = "-r";
+  status |= moduleTestBq241xxShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* bq27500 (fuel gauge) */
+  // front
+  targv[1] = "-f";
+  status |= moduleTestBq27500ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // rear
+  targv[1] = "-r";
+  status |= moduleTestBq27500ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* bq 27500 (fuel gauge) in combination with bq24103a (battery charger) */
+  // front
+  targv[1] = "-f";
+  status |= moduleTestBq27500Bq241xxShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // rear
+  targv[1] = "-r";
+  status |= moduleTestBq27500Bq241xxShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* INA219 (power monitor) */
+  // VDD
+  targv[1] = "VDD";
+  status |= moduleTestIna219ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // VIO 1.8V
+  targv[1] = "VIO1.8";
+  status |= moduleTestIna219ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // VIO 3.3V
+  targv[1] = "VIO3.3";
+  status |= moduleTestIna219ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // VSYS 4.2V
+  targv[1] = "VSYS4.2";
+  status |= moduleTestIna219ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // VIO 5.0V
+  targv[1] = "VIO5.0";
+  status |= moduleTestIna219ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* status LED */
+  status |= moduleTestLedShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* PKLCS1212E4001 (buzzer) */
+  status |= moduleTestPkxxxexxxShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* TPS62113 (step-down converter) */
+  status |= moduleTestTps6211xShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* TPS62113 (step-down converter) in combination with INA219 (power monitor) */
+  status |= moduleTestTps6211xIna219ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+#if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR)
+
+  /* MPR121 (touch sensor) */
+  status |= moduleTestMpr121ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* PCA9544A (I2C multiplexer) */
+  // #1
+  targv[1] = "#1";
+  status |= moduleTestPca9544aShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // #2
+  targv[1] = "#2";
+  status |= moduleTestPca9544aShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* VCNL4020 (proximity sensor) */
+  // north-northeast
+  targv[1] = "-nne";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // east-northeast
+  targv[1] = "-ene";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // east-southeast
+  targv[1] = "-ese";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // south-southeast
+  targv[1] = "-sse";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // south-southwest
+  targv[1] = "-ssw";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // west-southwest
+  targv[1] = "-wsw";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // west-northwest
+  targv[1] = "-wnw";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // west-northwest
+  targv[1] = "-nnw";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+#endif /* (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) */
+
+#if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X)
+
+  /* PCAL6524 (GPIO extender) */
+  // #1
+  targv[1] = "#1";
+  status |= moduleTestPcal6524ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // #2
+  targv[1] = "#2";
+  status |= moduleTestPcal6524ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* AT42QT1050 (touch sensor) */
+  status |= moduleTestAt42qt1050ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+#endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) */
+
+#if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X)
+
+  /* PCAL6524 (GPIO extender) */
+  // #1
+  targv[1] = "#1";
+  status |= moduleTestPcal6524ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // #2
+  targv[1] = "#2";
+  status |= moduleTestPcal6524ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  /* AT42QT1050 (touch sensor) */
+  status |= moduleTestAt42qt1050ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
 
 #endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) */
 
+  // print total result
+  chprintf(stream, "\n");
+  aosTestResultPrintSummary(stream, &result_total, "entire module");
+
+  return status;
+}
+AOS_SHELL_COMMAND(moduleTestAllShellCmd, "test:all", _testAllShellCmdCb);
+
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 /** @} */
diff --git a/modules/PowerManagement_1-2/module.h b/modules/PowerManagement_1-2/module.h
index 468e72f..9c20fcc 100644
--- a/modules/PowerManagement_1-2/module.h
+++ b/modules/PowerManagement_1-2/module.h
@@ -434,37 +434,38 @@ extern ROMCONST char* moduleShellPrompt;
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
   /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAdcVsys.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq24103a.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500.shellcmd);              \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500Bq24103a.shellcmd);      \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldPklcs1212e4001.shellcmd);       \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113Ina219.shellcmd);       \
+  aosShellAddCommand(&aos.shell, &moduleTestAdcShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestBq241xxShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestBq27500ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestBq27500Bq241xxShellCmd);          \
+  aosShellAddCommand(&aos.shell, &moduleTestIna219ShellCmd);                  \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestPkxxxexxxShellCmd);               \
+  aosShellAddCommand(&aos.shell, &moduleTestTps6211xShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTps6211xIna219ShellCmd);          \
   MODULE_INIT_TEST_SENSORRING();                                              \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPca9544a.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldMpr121.shellcmd);             \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldVcnl4020.shellcmd);           \
+    aosShellAddCommand(&aos.shell, &moduleTestPca9544aShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestMpr121ShellCmd);                \
+    aosShellAddCommand(&aos.shell, &moduleTestVcnl4020ShellCmd);              \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPcal6524.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldAt42qt1050.shellcmd);         \
+    aosShellAddCommand(&aos.shell, &moduleTestPcal6524ShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestAt42qt1050ShellCmd);            \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPcal6524.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldAt42qt1050.shellcmd);         \
+    aosShellAddCommand(&aos.shell, &moduleTestPcal6524ShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestAt42qt1050ShellCmd);            \
   }
 #else /* (BOARD_SENSORRING == ?) */
   #define MODULE_INIT_TEST_SENSORRING()         {}
@@ -473,8 +474,8 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
-  MODULE_INIT_PERIPHERY_COMM_SENSORRING();                                    \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
+  MODULE_INIT_PERIPHERY_IF_SENSORRING();                                      \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -497,7 +498,7 @@ extern ROMCONST char* moduleShellPrompt;
   pwmStart(&MODULE_HAL_PWM_BUZZER, &moduleHalPwmBuzzerConfig);                \
 }
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCA9544A_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCA9544A_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (VCNL4020_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? VCNL4020_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCA9544A_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCA9544A_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed; \
@@ -505,25 +506,25 @@ extern ROMCONST char* moduleShellPrompt;
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (MPR121_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? MPR121_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed; \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (AT42QT1050_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? AT42QT1050_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (AT42QT1050_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? AT42QT1050_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
   }
 #else /* (BOARD_SENSORRING == ?) */
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {}
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {}
 #endif /* (BOARD_SENSORRING == ?) */
 
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* PWM */                                                                   \
   pwmStop(&MODULE_HAL_PWM_BUZZER);                                            \
   /* ADC */                                                                   \
@@ -741,129 +742,114 @@ extern AT42QT1050Driver moduleLldTouch;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_lld_adc.h>
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_bq241xx_v1.h>
-#include <ut_alld_bq27500_v1.h>
-#include <ut_alld_bq27500_v1_bq241xx_v1.h>
-#include <ut_alld_INA219_v1.h>
-#include <ut_alld_LED_v1.h>
-#include <ut_alld_PKxxxExxx_v1.h>
-#include <ut_alld_TPS6211x_v1.h>
-#include <ut_alld_TPS6211x_v1_INA219_v1.h>
 
 /**
- * @brief   ADC unit test object.
+ * @brief   ADC test command.
  */
-extern aos_unittest_t moduleUtAdcVsys;
+extern aos_shellcommand_t moduleTestAdcShellCmd;
 
 /**
- * @brief   AT24C01BN-SH-B (EEPROM) unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   BQ24103A (battery charger) unit test object.
+ * @brief   bq24103a (battery charger) test command.
  */
-extern aos_unittest_t moduleUtAlldBq24103a;
+extern aos_shellcommand_t moduleTestBq241xxShellCmd;
 
 /**
- * @brief   BQ27500 (fuel gauge) unit test object.
+ * @brief   bq27500 (fuel gauge) test command.
  */
-extern aos_unittest_t moduleUtAlldBq27500;
+extern aos_shellcommand_t moduleTestBq27500ShellCmd;
 
 /**
- * @brief   BQ27500 (fuela gauge) in combination with BQ24103A (battery charger) unit test object.
+ * @brief   bq27500 (fuel gauge) in combination with bq24103a (battery charger) test command.
  */
-extern aos_unittest_t moduleUtAlldBq27500Bq24103a;
+extern aos_shellcommand_t moduleTestBq27500Bq241xxShellCmd;
 
 /**
- * @brief   INA219 (power monitor) unit test object.
+ * @brief   INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldIna219;
+extern aos_shellcommand_t moduleTestIna219ShellCmd;
 
 /**
- * @brief   Status LED unit test object.
+ * @brief   Status LED test command.
  */
-extern aos_unittest_t moduleUtAlldLed;
+extern aos_shellcommand_t moduleTestLedShellCmd;
 
 /**
- * @brief   PKLCS1212E4001 (buzzer) unit test object.
+ * @brief   PKLCS1212E4001 (buzzer) test command.
  */
-extern aos_unittest_t moduleUtAlldPklcs1212e4001;
+extern aos_shellcommand_t moduleTestPkxxxexxxShellCmd;
 
 /**
- * @brief   TPS62113 (step-down converter) unit test object.
+ * @brief   TPS62113 (step-down converter) test command.
  */
-extern aos_unittest_t moduleUtAlldTps62113;
+extern aos_shellcommand_t moduleTestTps6211xShellCmd;
 
 /**
- * @brief   TPS62113 (step-sown converter) in combination with INA219 (power monitor) unit test object.
+ * @brief   TPS62113 (step-sown converter) in combination with INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldTps62113Ina219;
+extern aos_shellcommand_t moduleTestTps6211xIna219ShellCmd;
 
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
 
-#include <ut_alld_MPR121_v1.h>
-#include <ut_alld_PCA9544A_v1.h>
-#include <ut_alld_VCNL4020_v1.h>
-
 /**
- * @brief   MPR121 (touch sensor) unit test object.
+ * @brief   MPR121 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldMpr121;
+extern aos_shellcommand_t moduleTestMpr121ShellCmd;
 
 /**
- * @brief   PCA9544A (I2C multiplexer) unit test object.
+ * @brief   PCA9544A (I2C multiplexer) test command.
  */
-extern aos_unittest_t moduleUtAlldPca9544a;
+extern aos_shellcommand_t moduleTestPca9544aShellCmd;
 
 /**
- * @brief   VCNL4020 (proximity sensor) unit test object.
+ * @brief   VCNL4020 (proximity sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldVcnl4020;
+extern aos_shellcommand_t moduleTestVcnl4020ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) */
 
 #if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCAL6524_v1.h>
-#include <ut_alld_AT42QT1050_v1.h>
-
 /**
- * @brief   PCAL6524 (GPIO extender) unit test object.
+ * @brief   PCAL6524 (GPIO extender) test command.
  */
-extern aos_unittest_t moduleUtAlldPcal6524;
+extern aos_shellcommand_t moduleTestPcal6524ShellCmd;
 
 /**
- * @brief   AT42QT1050 (touch sensor) unit test object.
+ * @brief   AT42QT1050 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldAt42qt1050;
+extern aos_shellcommand_t moduleTestAt42qt1050ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) */
 
 #if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCAL6524_v1.h>
-#include <ut_alld_AT42QT1050_v1.h>
-
 /**
- * @brief   PCAL6524 (GPIO extender) unit test object.
+ * @brief   PCAL6524 (GPIO extender) test command.
  */
-extern aos_unittest_t moduleUtAlldPcal6524;
+extern aos_shellcommand_t moduleTestPcal6524ShellCmd;
 
 /**
- * @brief   AT42QT1050 (touch sensor) unit test object.
+ * @brief   AT42QT1050 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldAt42qt1050;
+extern aos_shellcommand_t moduleTestAt42qt1050ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) */
 
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
+
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 /** @} */
diff --git a/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.c b/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.c
new file mode 100644
index 0000000..ee88d4c
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.c
@@ -0,0 +1,71 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_AT24C01B.h>
+#include <aos_test_AT24C01B.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_at24c01bdata_t _data = {
+  /* driver   */ &moduleLldEeprom,
+  /* timeout  */ MICROSECONDS_PER_SECOND,
+};
+
+static AOS_TEST(_test, "AT24C01BN-SH-B", "1kbit EEPROM", moduleTestAt24c01bShellCb, aosTestAt24c01bFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestAt24c01bShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.h b/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.h
new file mode 100644
index 0000000..6764c0d
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/AT24C01B/module_test_AT24C01B.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_AT24C01B_H
+#define MODULE_TEST_AT24C01B_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+   int moduleTestAt24c01bShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_AT24C01B_H */
+
